using System;
using System.IO;
using System.Text;
using System.Collections;
using System.Diagnostics;
using System.Runtime.InteropServices;

using Keyoti.SearchEngine;
using Keyoti.SearchEngine.Documents;
using Keyoti.SearchEngine.DataAccess;


namespace NewWordParser
{
	public class CustomParser:Parser
	{


        public CustomParser(string temporaryFilePath, Configuration configuration) : base(configuration)
        {
            this.tempFNAME = temporaryFilePath; 
        }


		string tempFNAME;

		void CopyStreamToTempFile(Stream stream)
		{
			BinaryReader br = new BinaryReader(stream);
			BinaryWriter bw = new BinaryWriter(new FileStream(tempFNAME, FileMode.Create));
			byte[] inbytes = new byte[1024];
			int read;
			while( (read = br.Read(inbytes, 0, inbytes.Length)) > 0)
			{
				bw.Write(inbytes, 0, read);
			}
			br.Close();
			bw.Close();
		}

		public override DocumentText  Read(Stream stream, Uri uri, Encoding e)
		{
            
			if(File.Exists(tempFNAME))
				File.Delete(tempFNAME);

			CopyStreamToTempFile(stream);
        
			string content = DefaultParser.Extract(tempFNAME);
			TxtDocumentParser parser = new TxtDocumentParser(Configuration);
			return parser.Read(content, uri, e);
		}	

	}


}
